#include "Persistence.h"

Persistence::Persistence()
{
    if (!LittleFS.begin())
    {
        Serial.println("An Error has occurred while mounting LittleFS");
        return;
    }
}
String Persistence::TestRead()
{
    File file = LittleFS.open("/users.json", "r");
    String result = "";
    if (!file)
    {
        Serial.println("Failed to open file for reading");
        return result;
    }
    Serial.println("File Content:");
    while (file.available())
    {
        result += (char)file.read();
    }
    file.close();
    return result;
}

Persistence::Configuration Persistence::loadConfig()
{
    StaticJsonDocument<1024> doc;
    File config_file = LittleFS.open("/config.json","r");
    deserializeJson(doc, config_file); 
    Configuration res;
    res.SSID=doc["SSID"].as<const char*>();
    res.PASS=doc["PASS"].as<const char*>();
    return res;
}
DynamicJsonDocument Persistence::readUsers(){
    File user_file = LittleFS.open("/users.json","r");
    size_t buffersize = user_file.size()+512;
    Serial.printf("Reserved %i for reading UserDB File", buffersize);
    DynamicJsonDocument doc(user_file.size()+512);
    deserializeJson(doc, user_file);
    user_file.close();
    return doc;
}
bool Persistence::saveUsers(DynamicJsonDocument &doc){
    File user_file = LittleFS.open("/users.json","w");
    serializeJson(doc, user_file);
    user_file.close();

    return true;
}