#include "UserDb.h"
#define DEBUG
using namespace userdb;

UserDb::UserDb(const char *filename) : filename(filename)
{
}

bool UserDb::remove_user(User &user)
{
    return remove_user_by_line(filename, user.line);
}
bool UserDb::add_user(User &user)
{

    File db = LittleFS.open(filename, "a");
    db.write("\n" + String(user.uid) + ";" + user.first_name + ";" + user.last_name + ";" + user.rfid_uid + ";" + user.user_pin + ";" + user.enabled ? "1" : "0");
    db.close();
    return true;
}
User UserDb::user_by_pin(String cmp)
{
#ifdef DEBUG
    Serial.println("Searching for user with pin number " + cmp);
#endif
    Iterator it = begin_with_filter(&cmp, USERATTRIBUTES::USER_PIN);
    do
    {
        User temp = *it;
        if (temp.enabled)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}
User UserDb::user_by_rfid(String cmp)
{
#ifdef DEBUG
    Serial.println("Searching for user with rfid " + cmp);
#endif
    Iterator it = begin_with_filter(&cmp, USERATTRIBUTES::RFID_UID);
    do
    {
        User temp = *it;
        if (temp.enabled)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}

User UserDb::user_by_uid(unsigned long cmp)
{
#ifdef DEBUG
    Serial.println("Searching for user with user id " + String(cmp));
#endif
    Iterator it = begin();
    do
    {
        User temp = *it;
        if (temp.uid == cmp)
            return temp;
        ++it;
    } while (it.has_next());
    return User{.enabled = false};
}
void UserDb::print_to_serial()
{
    Serial.println("Starting UserDB Test Read");
    for (Iterator it = begin(); it.has_next(); ++it)
    {
        User temp = *it;
        Serial.println(temp.toString());
    }
}
