import {
  BrowserRouter as Router,
  Routes ,
  Route,
} from "react-router-dom";
import React from 'react';
import { ThemeProvider } from "styled-components";
import {CreateUserWidget, RecentActivityWidget, SystemStatusWidget, ColourPalette} from './components'
import {AccountManager, AdminUI, Logs, System} from './views'
import theme from './theme';
function App() {
  return (
    <Router>
      <ThemeProvider theme={theme}>
      <AdminUI>
        <Routes >
          <Route path="/" exact element={
            <>          
            <CreateUserWidget />  
            <RecentActivityWidget />
            <SystemStatusWidget />
            </>
          }/>
          <Route path="/accounts" element={<AccountManager/>} />
          <Route path="/log" element={<Logs/>} />
          <Route path="/system" element={<System/>}/>
        </Routes >
      </AdminUI>
      </ThemeProvider>
    </Router>
  );
}

export default App;
